
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	xvisControl segment

	V1.0BETA  - last edited 01/07/96
    ============================================= */

// ---------------------------------------------
// Local Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>
#include <unistd.h>

// ---------------------------------------------
// Local Image files

#include <bitmaps/file.xpm>
#include <bitmaps/open.xpm>
#include <bitmaps/disk.xpm>
#include <bitmaps/info.xpm>
#include <bitmaps/cc.xpm>
#include <bitmaps/newform.xpm>
#include <bitmaps/editmenu.xpm>

// ---------------------------------------------
// Local Forward Function declarations

void func_file_new(Widget aw, XtPointer client, XtPointer call);
void func_file_changedir(Widget aw, XtPointer client, XtPointer call);
void func_file_projnew(Widget aw, XtPointer client, XtPointer call);
void func_file_projload(Widget aw, XtPointer client, XtPointer call);
void func_file_projsave(Widget aw, XtPointer client, XtPointer call);
void func_file_formload(Widget aw, XtPointer client, XtPointer call);
void func_file_formsave(Widget aw, XtPointer client, XtPointer call);
void func_file_formsaveas(Widget aw, XtPointer client, XtPointer call);

void func_newmod(Widget aw, XtPointer client, XtPointer call);
void func_loadmod(Widget aw, XtPointer client, XtPointer call);
void func_savemod(Widget aw, XtPointer client, XtPointer call);
void func_savemod_as(Widget aw, XtPointer client, XtPointer call);

void func_window_tool(Widget aw, XtPointer client, XtPointer call);
void func_window_prop(Widget aw, XtPointer client, XtPointer call);
void func_window_event(Widget aw, XtPointer client, XtPointer call);
void func_window_error(Widget aw, XtPointer client, XtPointer call);
void func_project_event(Widget aw, XtPointer client, XtPointer call);

void func_object_newwindow(Widget aw, XtPointer client, XtPointer call);
void func_object_remap(Widget aw, XtPointer client, XtPointer call);
void func_object_menu(Widget aw, XtPointer client, XtPointer call);
void func_object_showg(Widget aw, XtPointer client, XtPointer call);
void func_object_snapg(Widget aw, XtPointer client, XtPointer call);
void func_object_changeg(Widget aw, XtPointer client, XtPointer call);

void func_generate(Widget aw, XtPointer client, XtPointer call);
void func_codeonly(Widget aw, XtPointer client, XtPointer call);
void func_build(Widget aw, XtPointer client, XtPointer call);
void func_rebuild(Widget aw, XtPointer client, XtPointer call);
void func_run(Widget aw, XtPointer client, XtPointer call);
void func_help_about(Widget aw, XtPointer client, XtPointer call);
void formSaveExec();

extern CurrentModule;
extern saveCurrentModule();
extern void func_file_projsave(Widget aw, XtPointer client, XtPointer call);

// ---------------------------------------------
// Local Variable & Data declarations

char *controlmenu[]={ "File", "Object", "Generate", "Window", "Help"};

char *controlfilemenu[]={	"New",
						"---", 
						"Change Directory...", 
						"---", 
						"New Project", "Load Project", "Save Project", 
						"---", 
						"Load Form", "Save Form", "Save Form As...", 
						"---",
						"New Module", "Load Module", "Save Module",
						"---", 
						"Exit" 
						};

XtCallbackProc filemenuprocs[]={ func_file_new, 
							func_dummy, 
							func_file_changedir,
							func_dummy, 
							func_file_projnew, func_file_projload, func_file_projsave,
							func_dummy, 
							func_file_formload, func_file_formsave, func_file_formsaveas, 
							func_dummy, 
							func_newmod, func_loadmod, func_savemod_as, 
							func_dummy,
							func_exit};

char *objectmenu[]={ "New Form", "New/Edit Menu", "Remap Object...", "Show Grid", "Snap to Grid", "Alter Grid"};
XtCallbackProc objectmenuprocs[]={	func_object_newwindow, func_object_menu, 
								func_object_remap, func_object_showg, func_object_snapg, 
								func_object_changeg}; 

char *windowmenu[]={ "Tools", "Properties", "Events", "Project", "Errors" };
XtCallbackProc windowmenuprocs[]={ 	func_window_tool, func_window_prop,
								func_window_event, func_project_event,
								func_window_error };

char *genmenu[]={ "Generate Code Only", "Generate Code & Build", "Build", "ReBuild All", "Run" };
XtCallbackProc genprocs[]= { func_codeonly, func_generate, func_build, func_rebuild, func_run };

char *helpmenu[] = { "About..." };
XtCallbackProc helpprocs[]= {func_help_about};

int fileActionMode=0;
Boolean xlocked=FALSE;
xvPopupDialog projDialog;
Boolean err_active=FALSE;

// ---------------------------------------------
// Local Callbacks

void func_changepathok(Widget aw, XtPointer client, XtPointer call)
{
	strcpy(cwd, provpath);
	chdir(cwd);
	getcwd(cwd, 200);
	xvisPath.Close();
}

void func_file_changedir(Widget aw, XtPointer client, XtPointer call)
{
	buildPathWindow(func_changepathok);
	pathlist.SetNewPath(cwd, XVDIRLIST, TRUE);
	xvisPath.Open();
}

void func_fileselect_ok(Widget aw, XtPointer client, XtPointer call)
{
	int toplevel=objects[CurrentObject].parent_window;

	sprintf(objects[toplevel].obj_path, "%s.form", objects[toplevel].name);
	strcpy(provpath, xvisSelFile.SelectedFile(propeditbuffer));
	strcpy(objects[toplevel].obj_path, propeditbuffer);
	xvisSelectFile.RemoveGrab();
	xvisSelectFile.Close();
	execFileAction(fileActionMode, propeditbuffer);
}

void func_loadselect_ok(Widget aw, XtPointer client, XtPointer call)
{
	strcpy(provpath, xvisSelFile.SelectedFile(propeditbuffer));
	xvisSelectFile.RemoveGrab();
	xvisSelectFile.Close();
	execFileAction(fileActionMode, propeditbuffer);
}

void func_projselect_ok(Widget aw, XtPointer client, XtPointer call)
{
	strcpy(provpath, xvisSelFile.SelectedFile(propeditbuffer));
	strcpy(project_name, provpath);
	strcpy(project_path, propeditbuffer);
	xvisSelectFile.RemoveGrab();
	xvisSelectFile.Close();
	execFileAction(fileActionMode, propeditbuffer);
}

void execNew()
{
		
	for (int i=0; i<MAXOBJECTS; i++) {
		objects[i].changed=FALSE;
		if (objects[i].object_type==XVWindow)
			DeleteNamedObject(objects[i].name);
	}
	for (int i=0; i<MAXTOOLS; i++)
		objectInstance[i]=0;
	SetupPropertiesList(CurrentParent, TRUE);
	controlEventsData(FALSE);
	xvisObjectMenu.EntryResource("Remap Object...", XtNsensitive, FALSE);
	xvisObjectMenu.EntryResource("New/Edit Menu", XtNsensitive, FALSE);
	xvisEditMenu.SetSensitive(FALSE);
	xvisFileMenu.EntryResource("Save Form As...", XtNsensitive, FALSE);
	xvisFileMenu.EntryResource("Save Project", XtNsensitive, FALSE);
	xvisFileMenu.EntryResource("Save Form", XtNsensitive, FALSE);
	xvisGenerateMenu.EntryResource("Build", XtNsensitive, FALSE);
	xvisGenerateMenu.EntryResource("ReBuild All", XtNsensitive, FALSE);
	xvisGenerateMenu.EntryResource("Run", XtNsensitive, FALSE);
	xvisSave.SetSensitive(FALSE);

	project_name[0]='\0';
	project_path[0]='\0';
	for (int i=0; i<MAXPROJECTFILES; i++)
		project_list[i]=-1;

	for (int i=0; i<MAXEDITWINDOWS; i++)
		if (module[i].in_use) {
			delete module[i].editor;
			delete module[i].edit_buffer;
			module[i].changed=FALSE;
			module[i].in_use=FALSE;
			module[i].first=TRUE;
		}

	updateProjectListWindow();
}

void new_save_yes(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	func_file_projsave(0, NULL, NULL);
	execNew();
}

void new_save_no(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	execNew();
}

void func_file_new_yes(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();

	if (UnsavedData()) {
		alert.init("UNSAVED DATA", xvisControl, 
			"There is unsaved data.\n Do you want to save?",
			XVMSGSIMPLECHOICE, "green",
			new_save_yes, new_save_no);
		alert.Open();
	}
	else
		execNew();
}

void func_file_new_no(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
}

void func_file_new(Widget aw, XtPointer client, XtPointer call)
{
	if (nobject==0) return;

	alert.init("New...", xvisControl, 
		"New will destroy all current objects\nAre you sure you want to do this?",
		XVMSGSIMPLECHOICE, "green",
		func_file_new_yes, func_file_new_no);
	alert.Open();
}

void func_file_projnew_ok(Widget aw, XtPointer client, XtPointer call)
{
	char *which=(char *) client;
	if (strcmp(which, "OK")==0) {
		strcpy(project_name, projDialog.GetDialog());
		strcpy(project_path, cwd);
		strcat(project_path, "/");
		strcat(project_path, project_name);
		xvisFileMenu.EntryResource("Save Project", XtNsensitive, TRUE);
		updateProjectListWindow();
	}
	projDialog.Close();
}

void func_file_projnew(Widget aw, XtPointer client, XtPointer call)
{
	char tempbuffer[180];

	strcpy(tempbuffer, project_name);
	if (strlen(tempbuffer)==0) strcpy(tempbuffer, ".project");
	projDialog.init("ProjectName", xvisControl, tempbuffer, "Enter New Project Name");
	projDialog.AddButton("OK", func_file_projnew_ok, (XtPointer) "OK");
	projDialog.AddButton("Cancel", func_file_projnew_ok, (XtPointer) "Cancel");
	Widget ef=XtNameToWidget(projDialog.xvDialog::ID(), "value");
	Widget lf=XtNameToWidget(projDialog.xvDialog::ID(), "label");
	XtVaSetValues(lf, XtNfont, (XtArgVal) fontfont.FontRef(), NULL);
	XtTranslations trans=XtParseTranslationTable(
	"<Key>Return: no-op() \n\
	!Meta<Key> i: no-op()");
	XtOverrideTranslations(ef, trans);

	projDialog.xvDialog::SetWidth(200);
	projDialog.Open();	
}

void func_file_projload(Widget aw, XtPointer client, XtPointer call)
{
	fileActionMode=xvPROJECTLOAD;
 	buildSelectFileWindow("Load Project...", func_projselect_ok, ".project", TRUE, FALSE);
	xvisSelectFile.Open();
	xvisSelFile.UpdateFileBox(".project");
	xvisSelectFile.AddGrab(FALSE, FALSE);	
}

void func_file_projsave(Widget aw, XtPointer client, XtPointer call)
{
	int tempcurrent=CurrentObject, count=0, mcount=0;
	FILE *pp;
	
	for (int i=0; i<MAXPROJECTFILES; i++) {
		while (xlocked) 
			xvisContext.ServiceEvent();

		if (project_list[i]!=-1) {
			xlocked=TRUE;
			CurrentObject=project_list[i];
			formSaveExec();
			count++;
		}
	}

	for (int i=0; i<MAXEDITWINDOWS; i++) {
		while (xlocked)
			xvisContext.ServiceEvent();
		
		if (module[i].in_use) {
			xlocked=TRUE;
			CurrentModule=i;
			saveModule(FALSE);
			mcount++;
		}
	}
			
	CurrentObject=tempcurrent;

	if (strlen(project_path) > 0) {
		pp=fopen(project_path, "w");
		if (pp!=NULL) {
			fprintf(pp, "%d\n", count);
			for (int i=0; i<MAXPROJECTFILES; i++)
				if (project_list[i]!=-1)
					fprintf(pp, "%s\n", objects[project_list[i]].obj_path);
				fprintf(pp, "%d\n", mcount);
				for (int i=0; i<MAXEDITWINDOWS; i++)
					if (module[i].in_use)
						fprintf(pp, "%s\n", module[i].path);

			fclose(pp);
		}
	}
}

void func_file_formload(Widget aw, XtPointer client, XtPointer call)
{
	fileActionMode=xvFORMLOAD;
	buildSelectFileWindow("Load Form", func_loadselect_ok, ".form", TRUE);
	xvisSelectFile.Open();
	xvisSelFile.UpdateFileBox(".form");
	xvisSelectFile.AddGrab(FALSE, FALSE);
}

void func_file_formsave(Widget aw, XtPointer client, XtPointer call)
{
	formSaveExec();
}

// -----------------------------------------------------
//
void formSaveExec()
{
	char namebuffer[180];

	int toplevel=objects[CurrentObject].parent_window;
	fileActionMode=xvFORMSAVE;
	if (strlen(objects[toplevel].obj_path)==0){
		fileActionMode=xvFORMSAVEAS;
		sprintf(namebuffer, "%s.form", objects[toplevel].name);
		buildSelectFileWindow("Save Form", func_fileselect_ok, namebuffer);
		xvisSelectFile.Open();
		xvisSelFile.UpdateFileBox(namebuffer);
		xvisSelectFile.AddGrab(FALSE, FALSE);
	}
	else 
		execFileAction(fileActionMode, objects[toplevel].obj_path);
}

void func_file_formsaveas(Widget aw, XtPointer client, XtPointer call)
{
	int toplevel=objects[CurrentObject].parent_window;
	fileActionMode=xvFORMSAVEAS;
	sprintf(objects[toplevel].obj_path, "%s.form", objects[toplevel].name);
	buildSelectFileWindow("Save Form As", func_fileselect_ok, objects[toplevel].obj_path);
	xvisSelectFile.Open();
	xvisSelFile.UpdateFileBox(objects[toplevel].obj_path);
	xvisSelectFile.AddGrab(FALSE, FALSE);	
}

void func_window_tool(Widget aw, XtPointer client, XtPointer call)
{
	if (ToolsVisible) {
		xvisWindowMenu.UnCheckEntry("Tools");
		ToolsVisible=FALSE;
		xvisTools.Close();
	}
	else {	
		xvisWindowMenu.CheckEntry("Tools");
		ToolsVisible=TRUE;
		xvisTools.Open();
	}
}

void func_window_prop(Widget aw, XtPointer client, XtPointer call)
{
	if (PropsVisible) {
		xvisWindowMenu.UnCheckEntry("Properties");
		PropsVisible=FALSE;
		xvisProps.Close();
	}
	else {	
		xvisWindowMenu.CheckEntry("Properties");
		PropsVisible=TRUE;
		xvisProps.Open();
	}
}

void func_window_event(Widget aw, XtPointer client, XtPointer call)
{
	if (EventsVisible) {
		xvisWindowMenu.UnCheckEntry("Events");
		EventsVisible=FALSE;
		xvisEvents.Close();
	}
	else {	
		xvisWindowMenu.CheckEntry("Events");
		EventsVisible=TRUE;
		xvisEvents.Open();
	}
}

void func_project_event(Widget aw, XtPointer client, XtPointer call)
{
	if (ProjectListVisible) {
		xvisWindowMenu.UnCheckEntry("Project");
		ProjectListVisible=FALSE;
		xvisProjList.Close();
	}
	else {	
		xvisWindowMenu.CheckEntry("Project");
		ProjectListVisible=TRUE;
		xvisProjList.Open();
	}
}

void func_window_error(Widget aw, XtPointer client, XtPointer call)
{
	if (ErrorsVisible) {
		xvisWindowMenu.UnCheckEntry("Errors");
		ErrorsVisible=FALSE;
		XtUnmapWidget(xvisError.GetParent());
	}
	else {	
		xvisWindowMenu.CheckEntry("Errors");
		ErrorsVisible=TRUE;
		xvisError.xvEditField::SetResource(XtNstring, (XtArgVal) errorbuffer);
		if (err_active)
			XtMapWidget(xvisError.GetParent());
		else {
			xvisError.Open();
			err_active=TRUE;
		}
	}
}

void func_object_newwindow(Widget aw, XtPointer client, XtPointer call)
{
	CurrentObject=-1;
	CreateObject(XVWindow);
}

void func_objmap(Widget aw, XtPointer client, XtPointer call)
{
	xvisObjList.RemoveGrab();
	xvisObjList.Close();
	objects[selected_ref].pcore->Unmap();
	objects[selected_ref].pcore->Map();
}

void func_object_remap(Widget aw, XtPointer client, XtPointer call)
{
	buildObjectListWindow(func_objmap);
	openObjectListWindow(XVAll, -1);
}

void func_object_menu(Widget aw, XtPointer client, XtPointer call)
{
	if (CurrentObject != -1) openMenuWindow();
}

void func_object_showg(Widget aw, XtPointer client, XtPointer call)
{
	if (showGrid) {
		xvisObjectMenu.UnCheckEntry("Show Grid");
		showGrid=FALSE;
	}
	else {
		xvisObjectMenu.CheckEntry("Show Grid");
		showGrid=TRUE;
	}
	for (int i=0; i<nobject; i++)
		if (objects[i].object_type==XVWindow) {
			objects[i].pwindow->Unmap();
			objects[i].pwindow->Map();
		}

}

void func_object_snapg(Widget aw, XtPointer client, XtPointer call)
{
	if (snapToGrid) {
		xvisObjectMenu.UnCheckEntry("Snap to Grid");
		snapToGrid=FALSE;
	}
	else {
		xvisObjectMenu.CheckEntry("Snap to Grid");
		snapToGrid=TRUE;
	}
}

void func_object_changeg(Widget aw, XtPointer client, XtPointer call)
{
	openGridWindow();
}

void gen_yes(Widget aw, XtPointer client, XtPointer call)
{
		alert.Close();
		func_file_projsave(0, NULL, NULL);
		commenceCodeGeneration(FALSE);
}

void gen_no(Widget aw, XtPointer client, XtPointer call)
{	
		alert.Close();
		commenceCodeGeneration(FALSE);	
}

void func_generate(Widget aw, XtPointer client, XtPointer call)
{
	if (UnsavedData()) {
		alert.init("UNSAVED DATA", xvisControl, 
			"There is unsaved data.\n Do you want to save?",
			XVMSGSIMPLECHOICE, "green",
			gen_yes, gen_no);
		alert.Open();
	}
	else
		commenceCodeGeneration(FALSE);
}

void codegen_yes(Widget aw, XtPointer client, XtPointer call)
{
		alert.Close();
		func_file_projsave(0, NULL, NULL);
		commenceCodeGeneration(TRUE);
}

void codegen_no(Widget aw, XtPointer client, XtPointer call)
{	
		alert.Close();
		commenceCodeGeneration(TRUE);	
}

void func_codeonly(Widget aw, XtPointer client, XtPointer call)
{
	if (UnsavedData()) {
		alert.init("UNSAVED DATA", xvisControl, 
			"There is unsaved data.\n Do you want to save?",
			XVMSGSIMPLECHOICE, "green",
			codegen_yes, codegen_no);
		alert.Open();
	}
	else
		commenceCodeGeneration(TRUE);
}

void func_build(Widget aw, XtPointer client, XtPointer call)
{
	buildProgram(FALSE);
}

void func_rebuild(Widget aw, XtPointer client, XtPointer call)
{
	buildProgram(TRUE);
}

void func_run(Widget aw, XtPointer client, XtPointer call)
{
	runProgram();
}

void func_help_about(Widget aw, XtPointer client, XtPointer call)
{
	xvisAbout.Open();
}

void func_newmod(Widget aw, XtPointer client, XtPointer call)
{
	makeNewModule();
}

void func_loadmod(Widget aw, XtPointer client, XtPointer call)
{
	loadModule();
}

void func_savemod(Widget aw, XtPointer client, XtPointer call)
{
	saveModule(FALSE);
}

void func_savemod_as(Widget aw, XtPointer client, XtPointer call)
{
	saveModule(TRUE);
}

// ---------------------------------------------
// Local Events


// ---------------------------------------------
// Local Functions

void buildControlWindow()
{
	xvisControl.init("Xvisual 1.0.1", "xvisControl", xvisContext);
	xvisControl.SetBackground("gray70");
	xvisControl.SetWindowResource(XtNgeometry, (XtArgVal)"+250+90");
	xvisControl.SetWindowResource(XtNmaxWidth, 619);
	xvisControl.SetWindowResource(XtNmaxHeight, 72);
	xvisControl.SetWindowResource(XtNminWidth, 619);
	xvisControl.SetWindowResource(XtNminHeight, 72);
 	xvisControl.SetWindowResource(XtNiconPixmap, 
		xvisControl.SetPixmapInfo(xvis_xpm, NULL));

	xvisControlMenu.init("xvisControlMenu", xvisControl, 5, controlmenu);	
	xvisControlMenu.SetDistance(0, 0);
	xvisControlMenu.SetDefaultDistance(0);
	xvisControlMenu.SetFixedPosition(TRUE);
		xvisControlMenu.SetAllResource(XtNshadowWidth, 0);
		xvisControlMenu.ChangeFont("*times-*-r-*-140*");
		xvisControlMenu.SetResource("Help", XtNhorizDistance, 250);

	xvisFileMenu.init("File", 17, controlfilemenu, filemenuprocs, xvisControlMenu.GetButton("File"));
	xvisFileMenu.ChangeFont("*times-*-r-*-120*");
	xvisFileMenu.EntryResource("Save Form As...", XtNsensitive, FALSE);
	xvisFileMenu.EntryResource("Save Project", XtNsensitive, FALSE);
	xvisFileMenu.EntryResource("Save Form", XtNsensitive, FALSE);
	xvisFileMenu.EntryResource("Save Module", XtNsensitive, FALSE);

	xvisObjectMenu.init("Object", 6, objectmenu, objectmenuprocs, xvisControlMenu.GetButton("Object"));
	xvisObjectMenu.ChangeFont("*times-*-r-*-120*");
	xvisObjectMenu.EntryResource("Remap Object...", XtNsensitive, FALSE);
	xvisObjectMenu.EntryResource("New/Edit Menu", XtNsensitive, FALSE);
	xvisObjectMenu.CheckEntry("Show Grid");
	xvisObjectMenu.CheckEntry("Snap to Grid");

	xvisGenerateMenu.init("Generate", 5, genmenu, genprocs, xvisControlMenu.GetButton("Generate"));
	xvisGenerateMenu.ChangeFont("*times-*-r-*-120*");
	xvisGenerateMenu.EntryResource("Build", XtNsensitive, FALSE);
	xvisGenerateMenu.EntryResource("ReBuild All", XtNsensitive, FALSE);
	xvisGenerateMenu.EntryResource("Run", XtNsensitive, FALSE);

	xvisWindowMenu.init("Window", 5, windowmenu, windowmenuprocs, xvisControlMenu.GetButton("Window"));
	xvisWindowMenu.ChangeFont("*times-*-r-*-120*");
	xvisWindowMenu.CheckEntry("Tools");
	xvisWindowMenu.CheckEntry("Properties");
	xvisWindowMenu.CheckEntry("Events");
	xvisWindowMenu.CheckEntry("Project");

	xvisHelpMenu.init("Help", 1, helpmenu, helpprocs, xvisControlMenu.GetButton("Help"));
	xvisHelpMenu.ChangeFont("*times-*-r-*-120*");

	xvisNew.init("", xvisControl, func_file_new);	
		xvisNew.SetRelVertical(xvisControlMenu);		
		xvisNew.SetBackground("gray85");
		xvisNew.SetPixmapInfo(file_xpm, XtNbitmap);
		xvisNew.SetFixedPosition(TRUE);
		xvisNew.SetBeNiceToColormap(FALSE);
		xvisNew.SetShadowWidth(4);

	xvisOpen.init("", xvisControl, func_file_formload);	
		xvisOpen.SetRelative(xvisNew, xvisControlMenu);
		xvisOpen.SetBackground("gray85");
		xvisOpen.SetPixmapInfo(open_xpm, XtNbitmap);
		xvisOpen.SetHorizDistance(1);
		xvisOpen.SetFixedPosition(TRUE);
		xvisOpen.SetBeNiceToColormap(FALSE);
		xvisOpen.SetShadowWidth(4);

	xvisSave.init("", xvisControl, func_file_formsave);	
		xvisSave.SetRelative(xvisOpen, xvisControlMenu);
		xvisSave.SetBackground("gray85");
		xvisSave.SetPixmapInfo(disk_xpm, XtNbitmap);
		xvisSave.SetHorizDistance(1);
		xvisSave.SetSensitive(FALSE);
		xvisSave.SetFixedPosition(TRUE);
		xvisSave.SetBeNiceToColormap(FALSE);
		xvisSave.SetShadowWidth(4);

	xvisNewForm.init("", xvisControl, func_object_newwindow);	
		xvisNewForm.SetRelative(xvisSave, xvisControlMenu);
		xvisNewForm.SetBackground("gray85");
		xvisNewForm.SetPixmapInfo(newform_xpm, XtNbitmap);
		xvisNewForm.SetHorizDistance(20);
		xvisNewForm.SetFixedPosition(TRUE);
		xvisNewForm.SetBeNiceToColormap(FALSE);
		xvisNewForm.SetShadowWidth(4);

	xvisEditMenu.init("", xvisControl, func_object_menu);	
		xvisEditMenu.SetRelative(xvisNewForm, xvisControlMenu);
		xvisEditMenu.SetBackground("gray85");
		xvisEditMenu.SetPixmapInfo(editmenu_xpm, XtNbitmap);
		xvisEditMenu.SetHorizDistance(1);
		xvisEditMenu.SetFixedPosition(TRUE);
		xvisEditMenu.SetSensitive(FALSE);
		xvisEditMenu.SetBeNiceToColormap(FALSE);
		xvisEditMenu.SetShadowWidth(4);

	xvisCC.init("", xvisControl, func_generate);	
		xvisCC.SetRelative(xvisEditMenu, xvisControlMenu);
		xvisCC.SetBackground("gray85");
		xvisCC.SetPixmapInfo(cc_xpm, XtNbitmap);
		xvisCC.SetHorizDistance(20);
		xvisCC.SetFixedPosition(TRUE);
		xvisCC.SetBeNiceToColormap(FALSE);
		xvisCC.SetShadowWidth(4);

	xvisInfo.init("", xvisControl, func_help_about);	
		xvisInfo.SetRelative(xvisCC, xvisControlMenu);
		xvisInfo.SetBackground("gray85");
		xvisInfo.SetPixmapInfo(info_xpm, XtNbitmap);
		xvisInfo.SetHorizDistance(1);
		xvisInfo.SetFixedPosition(TRUE);
		xvisInfo.SetBeNiceToColormap(FALSE);
		xvisInfo.SetShadowWidth(4);

	sprintf(countvalue, "Objects : %d", nobject);

	xvisCount.init(countvalue, xvisControl);
		xvisCount.SetRelVertical(xvisControlMenu);
		xvisCount.SetBackground("SkyBlue");
		xvisCount.SetDistance(360, 15);
		xvisCount.SetWidth(125);
 		xvisCount.SetFixedPosition(TRUE);
		xvisCount.SetBeNiceToColormap(FALSE);

}

// ------------------------------------

